package com.example.kurzymen;

import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.net.NetworkInfo;
import android.content.Context;
import android.content.res.Resources;
import android.net.ConnectivityManager;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.math.RoundingMode;
import java.text.DecimalFormat;

public class MainActivity extends AppCompatActivity {

    static String sURL = "http://www.apilayer.net/api/live?access_key=364301a6cfaf4c45d5c6c3d93c114743&format=1";
    static Double dMena1;
    static Double dMena2;
    static Double dMena3;
    static Double dMena4;
    static Double dMena5;
    static Double dMena6;
    static String sJSON = "";


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        zjistPripojeni();
        nastavSpinner();
    }

    public void zjistPripojeni() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo pripojeni = cm.getActiveNetworkInfo();

        if ((pripojeni != null && pripojeni.isAvailable() && pripojeni.isConnected())){
            new NactiAsyncTask().execute();
        } else {
            Toast.makeText(getApplicationContext(), getString(R.string.er_internet), Toast.LENGTH_LONG).show();
        }
    }


    public void btnClicked(View view) {
        Double dZadani = zjistiZadani();

        String prevMen1 = zjistiMenu(R.id.spinner1);
        String prevMen2 = zjistiMenu(R.id.spinner2);

        vypisVysledek(dZadani, prevMen1, prevMen2);
    }

    protected String zjistiMenu(int sid){
        Spinner spin = (Spinner) findViewById(sid);
        String mena = spin.getSelectedItem().toString();
        return mena;
    }

    protected double zjistiZadani(){
        EditText etHodnotaIn = (EditText) findViewById(R.id.prevodIn);
        String sHodnitaIn = etHodnotaIn.getText().toString();
        Double dZadani;

        if(sHodnitaIn.isEmpty()) {
            dZadani = 0.0;
        } else {
            dZadani = Double.parseDouble(etHodnotaIn.getText().toString());
        }
        return dZadani;
    }

    protected double vypocti (double zadani, String prevMen1, String prevMen2) {
        Double dKurzIn = 0.0;
        Double dKurzOut = 0.0;
        Double vysledek;

        try {
            JSONObject jsonObject = new JSONObject(sJSON);
            JSONObject quotesJSONObject = jsonObject.getJSONObject("quotes");

            dKurzIn = quotesJSONObject.getDouble("USD"+prevMen1);
            dKurzOut = quotesJSONObject.getDouble("USD"+prevMen2);
        } catch (Exception e) {
            e.printStackTrace();
        }

        vysledek = zadani * (1 / dKurzIn) * dKurzOut;
        return vysledek;
    }

    protected void vypisVysledek(double dZadani, String prevMen1, String prevMen2){
        TextView tvO = (TextView)findViewById(R.id.prevodOut);
        TextView tvI = (TextView)findViewById(R.id.prevodInV);
        TextView rovnaSe = (TextView)findViewById(R.id.rovnaSe);

        DecimalFormat df = new DecimalFormat("#.####");
        df.setRoundingMode(RoundingMode.CEILING);

        String vystupI = String.valueOf(df.format(dZadani))+" "+prevMen1;
        String vystupO = String.valueOf(df.format(vypocti(dZadani, prevMen1, prevMen2)))+" "+prevMen2;

        tvI.setText(vystupI);
        rovnaSe.setText("=");
        tvO.setText(vystupO);
    }

    protected void nastavSpinner(){
        Spinner spinner = (Spinner) findViewById(R.id.spinner1);

        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(this, R.array.pMeny, android.R.layout.simple_spinner_item);
        spinner.setAdapter(adapter);

        spinner = (Spinner) findViewById(R.id.spinner2);

        adapter = ArrayAdapter.createFromResource(this, R.array.pMeny, android.R.layout.simple_spinner_item);
        spinner.setAdapter(adapter);

    }

    private class NactiAsyncTask extends AsyncTask<String, String, String> {


        protected String doInBackground(String... arg0){
            DefaultHttpClient klientHTTP = new DefaultHttpClient(new BasicHttpParams());
            HttpPost httppost = new HttpPost(sURL);
            httppost.setHeader("Content-type", "application/json");
            InputStream inputStream = null;

            sJSON = null;

            try {
                HttpResponse response = klientHTTP.execute(httppost);
                HttpEntity entity = response.getEntity();
                inputStream = entity.getContent();
                BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream, "UTF-8"), 8);
                StringBuilder sb = new StringBuilder();
                String radek = null;
                while ((radek = reader.readLine()) != null) {
                    sb.append(radek + "\n");
                }
                sJSON = sb.toString();
            } catch (Exception e) {
                e.printStackTrace();
            }
            finally {
                try {
                    if(inputStream != null) {
                        inputStream.close();
                    }
                } catch (Exception e){}
            }

            try {
                JSONObject jsonObject = new JSONObject(sJSON);

                JSONObject quotesJSONObject = jsonObject.getJSONObject("quotes");

                dMena1 = quotesJSONObject.getDouble("USDCZK");
                dMena2 = quotesJSONObject.getDouble("USDEUR");
                dMena3 = quotesJSONObject.getDouble("USDGBP");
                dMena4 = quotesJSONObject.getDouble("USDAUD");
                dMena5 = quotesJSONObject.getDouble("USDCNY");
                dMena6 = quotesJSONObject.getDouble("USDPLN");

            } catch (Exception e) {
                e.printStackTrace();
            }
            return sJSON;
        }

        protected void onPostExecute(String results) {

            vypis(R.id.mena1h, R.string.mena1, dMena1);
            vypis(R.id.mena2h, R.string.mena2, dMena2);
            vypis(R.id.mena3h, R.string.mena3, dMena3);
            vypis(R.id.mena4h, R.string.mena4, dMena4);
            vypis(R.id.mena5h, R.string.mena5, dMena5);
            vypis(R.id.mena6h, R.string.mena6, dMena6);


        }
    }

    protected void vypis(int tid, int sid, double mena){
        TextView tv = (TextView)findViewById(tid);

        Resources res = getResources();
        String t;
        double diUSD = (1/dMena1);

        if(R.id.mena1h == tid){
            t = res.getString(sid, mena);
        } else {
            t = res.getString(sid, 1/(mena*diUSD));
        }

        tv.setText(t);
    }
}